/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookLeadsConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookLeadsConnectorFormAllOf{}

// FacebookLeadsConnectorFormAllOf struct for FacebookLeadsConnectorFormAllOf
type FacebookLeadsConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Facebook page identifier
	PageId *string `json:"pageId,omitempty"`
	// Facebook form identifier
	FormId *string `json:"formId,omitempty"`
	// Facebook Leads attributes
	Attribute []string `json:"attribute,omitempty"`
	// Limit of post to be asked
	Limit *int32 `json:"limit,omitempty"`
	// Date range.
	DateRange *string `json:"dateRange,omitempty"`
}

// NewFacebookLeadsConnectorFormAllOf instantiates a new FacebookLeadsConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookLeadsConnectorFormAllOf() *FacebookLeadsConnectorFormAllOf {
	this := FacebookLeadsConnectorFormAllOf{}
	return &this
}

// NewFacebookLeadsConnectorFormAllOfWithDefaults instantiates a new FacebookLeadsConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookLeadsConnectorFormAllOfWithDefaults() *FacebookLeadsConnectorFormAllOf {
	this := FacebookLeadsConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookLeadsConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *FacebookLeadsConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetPageId returns the PageId field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetPageId() string {
	if o == nil || IsNil(o.PageId) {
		var ret string
		return ret
	}
	return *o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetPageIdOk() (*string, bool) {
	if o == nil || IsNil(o.PageId) {
		return nil, false
	}
	return o.PageId, true
}

// HasPageId returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasPageId() bool {
	if o != nil && !IsNil(o.PageId) {
		return true
	}

	return false
}

// SetPageId gets a reference to the given string and assigns it to the PageId field.
func (o *FacebookLeadsConnectorFormAllOf) SetPageId(v string) {
	o.PageId = &v
}

// GetFormId returns the FormId field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetFormId() string {
	if o == nil || IsNil(o.FormId) {
		var ret string
		return ret
	}
	return *o.FormId
}

// GetFormIdOk returns a tuple with the FormId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetFormIdOk() (*string, bool) {
	if o == nil || IsNil(o.FormId) {
		return nil, false
	}
	return o.FormId, true
}

// HasFormId returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasFormId() bool {
	if o != nil && !IsNil(o.FormId) {
		return true
	}

	return false
}

// SetFormId gets a reference to the given string and assigns it to the FormId field.
func (o *FacebookLeadsConnectorFormAllOf) SetFormId(v string) {
	o.FormId = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *FacebookLeadsConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

// GetLimit returns the Limit field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetLimit() int32 {
	if o == nil || IsNil(o.Limit) {
		var ret int32
		return ret
	}
	return *o.Limit
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.Limit) {
		return nil, false
	}
	return o.Limit, true
}

// HasLimit returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasLimit() bool {
	if o != nil && !IsNil(o.Limit) {
		return true
	}

	return false
}

// SetLimit gets a reference to the given int32 and assigns it to the Limit field.
func (o *FacebookLeadsConnectorFormAllOf) SetLimit(v int32) {
	o.Limit = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *FacebookLeadsConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookLeadsConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *FacebookLeadsConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *FacebookLeadsConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o FacebookLeadsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookLeadsConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.PageId) {
		toSerialize["pageId"] = o.PageId
	}
	if !IsNil(o.FormId) {
		toSerialize["formId"] = o.FormId
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	if !IsNil(o.Limit) {
		toSerialize["limit"] = o.Limit
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableFacebookLeadsConnectorFormAllOf struct {
	value *FacebookLeadsConnectorFormAllOf
	isSet bool
}

func (v NullableFacebookLeadsConnectorFormAllOf) Get() *FacebookLeadsConnectorFormAllOf {
	return v.value
}

func (v *NullableFacebookLeadsConnectorFormAllOf) Set(val *FacebookLeadsConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookLeadsConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookLeadsConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookLeadsConnectorFormAllOf(val *FacebookLeadsConnectorFormAllOf) *NullableFacebookLeadsConnectorFormAllOf {
	return &NullableFacebookLeadsConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableFacebookLeadsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookLeadsConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
